#ident	"$Header: /var/cvsroot/htdb/src/lib/log.c,v 1.31 2004/05/01 21:35:22 del Exp $"

/*
	Copyright  1994-2004 David Whittemore
	<del@adjective.com>, all rights reserved.

	Permission to use, copy, modify, and non-commercially distribute
	this software and its documentation for any purpose is hereby granted
	without fee, provided that the above copyright notice appear in all
	copies and that both that copyright notice and this permission notice
	appear in supporting documentation.  No representations are made about
	the suitability of this software for any purpose.  It is provided
	"as is" without express or implied warranty.
 */
#include	"libhtdb.h"

void	log_page(char *session_id, char *domain_id, char *user_id,
		char *affiliate_id, char *browser_id, char *resource, char *value)
{
	if (getenv("DOCUMENT_ROOT") != NULL &&
		htdb_checkval("confLogPageTable") &&
		!htdb_equal("browser->isrobot", "T")) {
			dbInsert("INSERT INTO %s set "
				"%s=%s, "
				"%s=%s, "
				"%s=%s, "
				"%s=%s, "
				"%s=%s, "
				"%s=%s, "
				"%s='%s', "
				"%s='%s' ",
					htdb_getval("confLogPageTable"),
					"page_id", "NULL",
					"session_id", session_id,
					"domain_id", domain_id,
					"user_id", user_id,
					"affiliate_id", affiliate_id,
					"browser_id", browser_id,
					"resource", resource,
					"value", value);

			if (htdb_checkval("cookie->wasSet") &&
				htdb_checkval("confLogEntranceTable"))
				/*
					and right here, we're going to drop some
					information into the `log.entrance' table
					so that we can track:
						1) how people found us
						2) what page they first landed on
				 */
				dbInsert("insert into %s set "
					"%s=%s, "
					"%s=%s, "
					"%s=%s, "
					"%s=%s, "
					"%s=%s, "
					"%s=%ld, "
					"%s='%s', "
					"%s='%s', "
					"%s=%s",
						htdb_getval("confLogEntranceTable"),
						"entrance_id", "NULL",
						"domain_id", domain_id,
						"session_id", session_id,
						"browser_id", browser_id,
						"affiliate_id", affiliate_id,
						"referer_id", htdb_getint("referer->referer_id"),
						"resource", resource,
						"value", value,
						"ts", "NULL");
	}
}

/*
	`istart' is a static, global structure!
 */
void	log_ttg(char *thing)
{
	if (htdb_checkval("confLogTimeToGenerateTable")) {
		struct timeval  istop;
		char	*hostname = htdb_uname("n");
		int		len = strlen(hostname);

		while (len > 0 && isspace(hostname[len - 1]))
			hostname[--len] = '\0';

		gettimeofday(&istop, (void *)NULL);
		dbInsert("insert into %s set "
			"ttg_id = NULL, "
			"domain_id = %ld, "
			"hostname = '%s', "
			"resource = '%s', "
			"begts = %ld.%06ld, "
			"endts = %ld.%06ld",
			htdb_getval("confLogTimeToGenerateTable"),
			htdb_getint("_domain_id"),
			hostname,
			thing,
			istart.tv_sec, istart.tv_usec,
			istop.tv_sec, istop.tv_usec);

		free(hostname);
	}
}
